Juha-Matti Santala
Community Builder. Dreamer. Adventurer.

Advent of Code - 2023

This is a solution to Day 15 of Advent of Code 2023.

Day 15: Lens Library

The newly-focused parabolic reflector dish is sending all of the collected light to a point on the side of yet another mountain - the largest mountain on Lava Island. As you approach the mountain, you find that the light is being collected by the wall of a large facility embedded in the mountainside.

You find a door under a large sign that says "Lava Production Facility" and next to a smaller sign that says "Danger - Personal Protective Equipment required beyond this point".

As you step inside, you are immediately greeted by a somewhat panicked reindeer wearing goggles and a loose-fitting hard hat. The reindeer leads you to a shelf of goggles and hard hats (you quickly find some that fit) and then further into the facility. At one point, you pass a button with a faint snout mark and the label "PUSH FOR HELP". No wonder you were loaded into that trebuchet so quickly!

You pass through a final set of doors surrounded with even more warning signs and into what must be the room that collects all of the light from outside. As you admire the large assortment of lenses available to further focus the light, the reindeer brings you a book titled "Initialization Manual".

"Hello!", the book cheerfully begins, apparently unaware of the concerned reindeer reading over your shoulder. "This procedure will let you bring the Lava Production Facility online - all without burning or melting anything unintended!"

"Before you begin, please be prepared to use the Holiday ASCII String Helper algorithm (appendix 1A)." You turn to appendix 1A. The reindeer leans closer with interest.

The HASH algorithm is a way to turn any string of characters into a single number in the range 0 to 255. To run the HASH algorithm on a string, start with a current value of 0. Then, for each character in the string starting from the beginning:

  • Determine the ASCII code for the current character of the string.
  • Increase the current value by the ASCII code you just determined.
  • Set the current value to itself multiplied by 17.
  • Set the current value to the remainder of dividing itself by 256.

After following these steps for each character in the string in order, the current value is the output of the HASH algorithm.

So, to find the result of running the HASH algorithm on the string HASH:

  • The current value starts at 0.
  • The first character is H; its ASCII code is 72.
  • The current value increases to 72.
  • The current value is multiplied by 17 to become 1224.
  • The current value becomes 200 (the remainder of 1224 divided by 256).
  • The next character is A; its ASCII code is 65.
  • The current value increases to 265.
  • The current value is multiplied by 17 to become 4505.
  • The current value becomes 153 (the remainder of 4505 divided by 256).
  • The next character is S; its ASCII code is 83.
  • The current value increases to 236.
  • The current value is multiplied by 17 to become 4012.
  • The current value becomes 172 (the remainder of 4012 divided by 256).
  • The next character is H; its ASCII code is 72.
  • The current value increases to 244.
  • The current value is multiplied by 17 to become 4148.
  • The current value becomes 52 (the remainder of 4148 divided by 256).

So, the result of running the HASH algorithm on the string HASH is 52.

The initialization sequence (your puzzle input) is a comma-separated list of steps to start the Lava Production Facility. Ignore newline characters when parsing the initialization sequence. To verify that your HASH algorithm is working, the book offers the sum of the result of running the HASH algorithm on each step in the initialization sequence.

For example:

rn=1,cm-,qp=3,cm=2,qp-,pc=4,ot=9,ab=5,pc-,pc=6,ot=7

This initialization sequence specifies 11 individual steps; the result of running the HASH algorithm on each of the steps is as follows:

  • rn=1 becomes 30.
  • cm- becomes 253.
  • qp=3 becomes 97.
  • cm=2 becomes 47.
  • qp- becomes 14.
  • pc=4 becomes 180.
  • ot=9 becomes 9.
  • ab=5 becomes 197.
  • pc- becomes 48.
  • pc=6 becomes 214.
  • ot=7 becomes 231.

In this example, the sum of these results is 1320. Unfortunately, the reindeer has stolen the page containing the expected verification number and is currently running around the facility with it excitedly.

Run the HASH algorithm on each step in the initialization sequence. What is the sum of the results? (The initialization sequence is one long line; be careful when copy-pasting it.)

Read input

Today's input is a single line with comma separated values. I strip out the possible newline in the input and split by comma. Final sequence is then the first value in all the lines.

from utils import read_input

def transformer(line):
    return line.strip().split(',')

sequence = read_input(15, transformer)[0]

Calculation of the hash is step-by-step implementation from the instructions. Python's built-in ord() function gives us the ASCII value for a given character.

def calculate_hash(word):
    hash_value = 0
    for ch in word:
        hash_value = hash_value + ord(ch)
        hash_value = hash_value * 17
        hash_value = hash_value % 256
    return hash_value

To calculate the final result, we calculate hash for each step and sum them up.

part_1 = 0
for step in sequence:
    part_1 += calculate_hash(step)

print(f'Solution: {part_1}')
assert part_1 == 517965

Solution: 517965

Part 2

You convince the reindeer to bring you the page; the page confirms that your HASH algorithm is working.

The book goes on to describe a series of 256 boxes numbered 0 through 255. The boxes are arranged in a line starting from the point where light enters the facility. The boxes have holes that allow light to pass from one box to the next all the way down the line.

     +-----+  +-----+         +-----+
Light | Box |  | Box |   ...   | Box |
----------------------------------------->
     |  0  |  |  1  |   ...   | 255 |
     +-----+  +-----+         +-----+

Inside each box, there are several lens slots that will keep a lens correctly positioned to focus light passing through the box. The side of each box has a panel that opens to allow you to insert or remove lenses as necessary.

Along the wall running parallel to the boxes is a large library containing lenses organized by focal length ranging from 1 through 9. The reindeer also brings you a small handheld label printer.

The book goes on to explain how to perform each step in the initialization sequence, a process it calls the Holiday ASCII String Helper Manual Arrangement Procedure, or HASHMAP for short.

Each step begins with a sequence of letters that indicate the label of the lens on which the step operates. The result of running the HASH algorithm on the label indicates the correct box for that step.

The label will be immediately followed by a character that indicates the operation to perform: either an equals sign (=) or a dash (-).

If the operation character is a dash (-), go to the relevant box and remove the lens with the given label if it is present in the box. Then, move any remaining lenses as far forward in the box as they can go without changing their order, filling any space made by removing the indicated lens. (If no lens in that box has the given label, nothing happens.)

If the operation character is an equals sign (=), it will be followed by a number indicating the focal length of the lens that needs to go into the relevant box; be sure to use the label maker to mark the lens with the label given in the beginning of the step so you can find it later. There are two possible situations:

  • If there is already a lens in the box with the same label, replace the old lens with the new lens: remove the old lens and put the new lens in its place, not moving any other lenses in the box.
  • If there is not already a lens in the box with the same label, add the lens to the box immediately behind any lenses already in the box. Don't move any of the other lenses when you do this. If there aren't any lenses in the box, the new lens goes all the way to the front of the box.

Here is the contents of every box after each step in the example initialization sequence above:

After "rn=1":
Box 0: [rn 1]

After "cm-":
Box 0: [rn 1]

After "qp=3":
Box 0: [rn 1]
Box 1: [qp 3]

After "cm=2":
Box 0: [rn 1] [cm 2]
Box 1: [qp 3]

After "qp-":
Box 0: [rn 1] [cm 2]

After "pc=4":
Box 0: [rn 1] [cm 2]
Box 3: [pc 4]

After "ot=9":
Box 0: [rn 1] [cm 2]
Box 3: [pc 4] [ot 9]

After "ab=5":
Box 0: [rn 1] [cm 2]
Box 3: [pc 4] [ot 9] [ab 5]

After "pc-":
Box 0: [rn 1] [cm 2]
Box 3: [ot 9] [ab 5]

After "pc=6":
Box 0: [rn 1] [cm 2]
Box 3: [ot 9] [ab 5] [pc 6]

After "ot=7":
Box 0: [rn 1] [cm 2]
Box 3: [ot 7] [ab 5] [pc 6]

All 256 boxes are always present; only the boxes that contain any lenses are shown here. Within each box, lenses are listed from front to back; each lens is shown as its label and focal length in square brackets.

To confirm that all of the lenses are installed correctly, add up the focusing power of all of the lenses. The focusing power of a single lens is the result of multiplying together:

  • One plus the box number of the lens in question.
  • The slot number of the lens within the box: 1 for the first lens, 2 for the second lens, and so on.
  • The focal length of the lens.

At the end of the above example, the focusing power of each lens is as follows:

  • rn: 1 (box 0) _ 1 (first slot) _ 1 (focal length) = 1
  • cm: 1 (box 0) _ 2 (second slot) _ 2 (focal length) = 4
  • ot: 4 (box 3) _ 1 (first slot) _ 7 (focal length) = 28
  • ab: 4 (box 3) _ 2 (second slot) _ 5 (focal length) = 40
  • pc: 4 (box 3) _ 3 (third slot) _ 6 (focal length) = 72

So, the above example ends up with a total focusing power of 145.

With the help of an over-enthusiastic reindeer in a hard hat, follow the initialization sequence. What is the focusing power of the resulting lens configuration?

The hardest part today for me was reading. Despite multiple reads, I missed that in the second part we're supposed to hash only the label part (the part before =/-).

In my solution, I take advantage of the fact that since Python 3.7, dictionaries are guaranteed to return items in insertion order. I initially had a OrderedDict since I wasn't quite sure if this was guarantee as some documentation has said it's like this for now but that it's an implementation detail that can change.

But reading through OrderedDict documentation, it says:

Ordered dictionaries are just like regular dictionaries but have some extra capabilities relating to ordering operations. They have become less important now that the built-in dict class gained the ability to remember insertion order (this new behavior became guaranteed in Python 3.7).

and I'll trust that for now.

My HASHMAP is a dictionary with dictionaries inside. In the lenses dictionary, I store the label and its corresponding focal length. This makes replacing and deleting lenses efficient compared to for example storing them in a list or a tuple.

To create the HASHMAP, I go through each step in sequence and depending on the operator (= or -), add or remove it from the HASHMAP. To calculate the focusing power, I iterate over each box and all the lenses in that box and calculate power for each lense based on the formula provided in the puzzle and sum them all up.

def add_to_hashmap(step, hashmap):
    label, focal_length = step.split('=')

    key = calculate_hash(label)
    lenses = hashmap.get(key, {})

    lenses[label] = int(focal_length)
    hashmap[key] = lenses

def delete_from_hashmap(step, hashmap):
    label = step.split('-')[0]

    key = calculate_hash(label)
    lenses = hashmap.get(key, {})

    if label in lenses:
        del lenses[label]
    hashmap[key] = lenses

def create_hashmap(sequence):
    hashmap = {}
    for step in sequence:
        if '=' in step:
            add_to_hashmap(step, hashmap)
        if '-' in step:
            delete_from_hashmap(step, hashmap)
    return hashmap

def calculate_focusing_power(hashmap):
    focusing_power = 0
    for box, lenses in hashmap.items():
        for slot, (label, focal_length) in enumerate(lenses.items(), start=1):
            focusing_power += (box + 1) * slot * focal_length
    return focusing_power
hashmap = create_hashmap(sequence)
part_2 = calculate_focusing_power(hashmap)

print(f'Solution: {part_2}')
assert part_2 == 267372

Solution: 267372

Two stars

30 is such a nice round number and today's puzzle was a perfect snack for Friday.